unit permutation;

interface

// http://en.wikipedia.org/wiki/Permutation

type
  TPermutation = class(TObject)
  private
    N: integer;
    FnumLeft,Ftotal: int64;
  public
    indices: array of integer;
    constructor Create(aN: integer); overload;
    destructor Destroy; override;
    function HasMore: boolean;
    procedure Next;
    property NumLeft: int64 read FnumLeft;
    property Total: int64 read FTotal;
  end;

implementation

function Factorial(n: integer): int64;
var
  i: integer;
begin
  result:= 1;
  for i:= 2 to n do result:= result*i;
end;

{ TPermutation }

constructor TPermutation.Create(aN: integer);
begin
  inherited create;
  N:= aN;
  setlength(indices,aN);
  Ftotal:= Factorial(aN);
  FnumLeft:= Ftotal;
end;

function TPermutation.HasMore: boolean;
begin
  result:= (numLeft<>0);
end;

procedure TPermutation.Next;
var
  i,j,fact,swapvar: integer;
begin
  for i:= 0 to N-1 do indices[i]:= i;
  fact:= 1;
  for i:= 2 to N do
  begin
    fact:= fact*(i-1);
    j:= i - (((Total-numLeft) div fact) mod i);
    swapvar:= indices[j-1];
    indices[j-1]:= indices[i-1];
    indices[i-1]:= swapvar;
  end;
  dec(FnumLeft);
end;

destructor TPermutation.destroy;
begin
  indices:= nil;
  inherited;
end;

end.
